Attribute VB_Name = "modGUI"
Public Enum enumGUIState
    GUI_CHAT = 1
    GUI_CONFIG = 2
    GUI_JOIN = 3
    GUI_CREATE = 4
    GUI_GAME = 5
End Enum

Public hGUIA        As enumGUIState 'current GUI state
Public hGUIB        As enumGUIState 'last GUI state
Public hGUI         As Object

Public Sub GUIUpdate(ByVal eState As enumGUIState)
    If (hGUIA = eState) Then Exit Sub
    hGUIB = hGUIA
    hGUIA = eState
    '//Delete any GUI object loaded
    If (Not hGUI Is Nothing) Then Call hGUI.Clear
    Set hGUI = Nothing
    '//Make sure any unused controls are not visible
    Call modCtrl.ClearCtrls
    '//Load the new GUI object
    Select Case hGUIA
        Case GUI_CHAT:      Set hGUI = New clsGUIChat
        Case GUI_CONFIG:    Set hGUI = New clsGUIConfig
        Case GUI_JOIN:      Set hGUI = New clsGUIJoin
        Case GUI_CREATE:    Set hGUI = New clsGUICreate
        Case GUI_GAME:      Set hGUI = New clsGUIGame
    End Select
End Sub
