Attribute VB_Name = "modMAP"
Public Sub SaveMap(ByVal lngChecksum As Long, _
                   ByVal strMapPath As String, _
                   ByRef strData As String)
    On Error GoTo SaveMapErr
    Dim FF          As Integer
    Dim lngIcon     As Long
    If (Not Len(Dir$(strMapPath)) = 0) Then Call Kill(strMapPath)
    FF = FreeFile()
    Open strMapPath For Binary As #FF
        Put #FF, 1, strData
    Close #FF
    lngIcon = modCtrl.hSCGP.GetMapIcon(strMapPath)
    Call SetMapTime(lngIcon, lngChecksum, strMapPath)
SaveMapErr:
End Sub
Public Function HaveMap(ByVal lngLengh As Long, _
                        ByVal lngChecksum As Long, _
                        ByVal strMapPath As String) As Boolean
    Dim udtFT           As FILETIMESTRUT
    If (Len(Dir$(strMapPath)) = 0) Then Exit Function
    If (Not lngLengh = FileLen(strMapPath)) Then Exit Function
    If (GetFileDate(strMapPath, udtFT) = False) Then Exit Function
    If (Not udtFT.dwLowDateTime = lngChecksum) Then Exit Function
    HaveMap = True
End Function
Public Sub GetMapData(ByVal strMapPath As String, _
                      ByRef strData As String)
    Dim FF          As Integer
    FF = FreeFile()
    Open strMapPath For Binary Lock Read As #FF
        strData = String(LOF(FF), 0)
        Get #FF, 1, strData
    Close #FF
End Sub
                           
Private Sub SetMapTime(ByVal lngIcon As Long, _
                       ByVal lngChecksum As Long, _
                       ByVal strMapPath As String)
    Dim udtFT           As FILETIMESTRUT
    udtFT.dwLowDateTime = lngChecksum
    udtFT.dwHighDateTime = lngIcon
    Call SetFileDate(strMapPath, udtFT)
End Sub
Public Function MapPreview(ByVal strMAP As String, ByVal strPAL As String, ByVal lngHdc As Long) As Boolean
    'strMAP = map file to make preview of
    'strPAL = folder to the palettes
    On Error GoTo MapPreviewErr
    If (Len(Dir$(strMAP)) = 0) Then Exit Function
    If (Len(strPAL) = 0) Then Exit Function
    Dim pic         As StdPicture
    Dim strCHK      As String
    Dim S           As String
    Dim strCOL      As String
    Dim strUNIT     As String
    Dim R           As RECT
    Dim i           As Long
    Dim i2          As Long
    Dim lngWidth    As Long
    Dim lngHeight   As Long
    Dim A           As Long
    Dim B           As Long
    Dim C           As Long
    Dim D           As Long
    Dim lngDC       As Long
    Dim X           As Integer
    Dim Y           As Integer
    Dim SizeX       As Long
    Dim SizeY       As Long
    Dim StartX      As Long
    Dim StartY      As Long
    Dim Width       As Long
    Dim Height      As Long
    Dim bW2BN       As Boolean
    Const MiniSize  As Long = 128
    
    '//Check if its a MPQ
    X = FreeFile()
    Open strMAP For Binary As #X
        Get #X, 1, i
        bW2BN = (Not i = &H1A51504D) 'MPQ
        If bW2BN Then
            strCHK = String(LOF(X), 0)
            Get #X, 1, strCHK
        End If
    Close #X
    X = 0
    
    '//Extract the map file
    If (bW2BN = False) Then
        If (modCtrl.hSCGP.ReadMPQFile(strMAP, "staredit\scenario.chk", strCHK) = False) Then Exit Function
    End If
    
    '//Read each section
    C = 1
    Do Until ((C + 7) > Len(strCHK))
        Call CopyMemory(A, ByVal Mid$(strCHK, C, 4), 4): C = C + 4
        Call CopyMemory(B, ByVal Mid$(strCHK, C, 4), 4): C = C + 4
        'If (A = &H454C4954) Then   'TILE'
        If (A = &H4D58544D) Then 'MTXM'
            If (Len(S) = 0) Then S = Mid$(strCHK, C, B)
        ElseIf (A = &H204D4944) Then 'DIM '
            Call CopyMemory(lngWidth, ByVal Mid$(strCHK, C, 2), 2)
            Call CopyMemory(lngHeight, ByVal Mid$(strCHK, C + 2, 2), 2)
        ElseIf (A = &H20415245) Then 'ERA '
            Call CopyMemory(D, ByVal Mid$(strCHK, C, 2), 2)
            D = IIf(bW2BN, (D And &H3), (D And &H7))
        ElseIf (A = &H524C4F43) Then 'COLR'
            If (B > 0) Then strCOL = Mid$(strCHK, C, B)
        ElseIf (A = &H54494E55) Then 'UNIT'
            If (B > 0) Then strUNIT = Mid$(strCHK, C, B)
        End If
        C = C + B
    Loop
    strCHK = vbNullString
    If (lngWidth < 32) Or (lngWidth > 256) Then Exit Function
    If (lngHeight < 32) Or (lngHeight > 256) Then Exit Function
    If (Len(S) < ((lngWidth * lngHeight) * 2)) Then Exit Function

    '//Load the palette
    If (Not Right$(strPAL, 1) = "\") Then strPAL = strPAL & "\"
    Set pic = LoadPicture(strPAL & IIf(bW2BN, "W", vbNullString) & D & ".bmp")
    If (pic Is Nothing) Then Exit Function

    '//Create a dc to the palette bitmap
    lngDC = CreateCompatibleDC(lngHdc)
    Call SelectObject(lngDC, pic.Handle)
    
    '//Scale the drawing to to fit in a 128 by 128 mini map
    If ((lngWidth = 96) Or (lngWidth = 192)) Then StartX = (MiniSize / 8)
    If ((lngHeight = 96) Or (lngHeight = 192)) Then StartY = (MiniSize / 8)
    Width = MiniSize
    Height = MiniSize
    SizeX = (MiniSize / (lngWidth - 1))
    SizeY = (MiniSize / (lngHeight - 1))
    If (lngWidth = lngHeight) Then
        If (lngWidth = 96) Or (lngWidth = 192) Then
            Width = MiniSize - (StartX * 2)
            Height = MiniSize - (StartY * 2)
        End If
    ElseIf (lngWidth > lngHeight) Then
        If (lngWidth = 96) Or (lngWidth = 192) Then
            Width = MiniSize - (StartX * 2)
            Height = (((MiniSize - (StartX * 2)) / lngWidth) * lngHeight)
        Else
            Height = ((MiniSize / lngWidth) * lngHeight)
        End If
        StartY = ((MiniSize / 2) - (Height / 2))
    ElseIf (lngWidth < lngHeight) Then
        If (lngHeight = 96) Or (lngHeight = 192) Then
            Height = MiniSize - (StartY * 2)
            Width = (((MiniSize - (StartY * 2)) / lngHeight) * lngWidth)
        Else
            Width = ((MiniSize / lngHeight) * lngWidth)
        End If
        StartX = ((MiniSize / 2) - (Width / 2))
    End If
    
    '//Draw the image
    A = 1
    For i = 0 To (lngHeight - 1)
        For i2 = 0 To (lngWidth - 1)
            Y = Asc(Mid$(S, A, 1))
            X = Asc(Mid$(S, A + 1, 1))
            A = A + 2
            Call StretchBlt(lngHdc, _
                StartX + (i2 * (Height / lngHeight)), _
                StartY + (i * (Width / lngWidth)), _
                SizeX, _
                SizeY, _
                lngDC, (X * 2), (Y * 2), 2, 2, vbSrcCopy)
        Next i2
    Next i
    Call DeleteDC(lngDC)
     
    '//Find start locations/minerals and draw them to scale
    A = 1
    B = 0
    i = IIf(bW2BN, 7, 35)
    Do Until ((A + i) > Len(strUNIT))
        If bW2BN Then
            Call CopyMemory(X, ByVal Mid$(strUNIT, A, 2), 2)
            Call CopyMemory(Y, ByVal Mid$(strUNIT, A + 2, 2), 2)
            B = Asc(Mid$(strUNIT, A + 4, 1))
            SizeY = Asc(Mid$(strUNIT, A + 5, 1)) And 7
            i2 = ((B = 92) Or (B = 94) Or (B = 95))
        Else
            Call CopyMemory(X, ByVal Mid$(strUNIT, A + 4, 2), 2): X = X \ 32
            Call CopyMemory(Y, ByVal Mid$(strUNIT, A + 6, 2), 2): Y = Y \ 32
            Call CopyMemory(B, ByVal Mid$(strUNIT, A + 8, 2), 2)
            SizeY = Asc(Mid$(strUNIT, A + 16, 1)) And 7
            i2 = ((B = 176) Or (B = 177) Or (B = 178) Or (B = 188) Or (B = 214))
        End If
        If i2 Then
            'min1/min2/min3/gas/startlocation
            If (((B = 176) Or (B = 177) Or (B = 178)) And (bW2BN = False)) Then 'mineral
                '2 wide, 1 high
                C = X + 1
                D = Y
                SizeX = RGB(64, 104, 212)
            ElseIf ((B = 188) And (bW2BN = False)) Then 'gas
                '4 wide, 2 high
                C = X + 2
                D = Y
                X = X - 1
                Y = Y - 1
                SizeX = RGB(64, 104, 212)
            ElseIf ((B = 92) And bW2BN) Then  'gold mine
                C = X + 2
                D = Y + 2
                SizeX = RGB(255, 255, 0)
            Else 'Player
                '4 wide, 3 high
                If (SizeY < Len(strCOL)) Then SizeY = Asc(Mid$(strCOL, SizeY + 1, 1))
                Select Case SizeY
                    Case 0:     SizeX = IIf(bW2BN, RGB(164, 0, 0), RGB(244, 4, 4))
                    Case 1:     SizeX = IIf(bW2BN, RGB(0, 60, 192), RGB(12, 72, 204))
                    Case 2:     SizeX = RGB(44, 180, 148)
                    Case 3:     SizeX = IIf(bW2BN, RGB(44, 180, 148), RGB(136, 64, 156))
                    Case 4:     SizeX = IIf(bW2BN, RGB(152, 72, 176), RGB(248, 140, 20))
                    Case 5:     SizeX = IIf(bW2BN, RGB(240, 132, 20), RGB(112, 48, 20))
                    Case 6:     SizeX = IIf(bW2BN, RGB(40, 40, 60), RGB(204, 224, 208))
                    Case 7:     SizeX = IIf(bW2BN, RGB(252, 252, 72), RGB(252, 252, 56))
                    Case 8:     SizeX = RGB(8, 128, 8)
                    Case 9:     SizeX = RGB(252, 252, 124)
                    Case 10:    SizeX = RGB(236, 196, 176)
                    Case 11:    SizeX = RGB(64, 104, 212) '(minerals)
                    Case 12:    SizeX = RGB(116, 164, 124)
                    Case 13:    SizeX = RGB(144, 144, 184)
                    Case 14:    SizeX = RGB(252, 252, 124)
                    Case 15:    SizeX = RGB(0, 220, 252)
                    Case Else:  SizeX = RGB(5, 5, 5)
                End Select
                C = X + 2
                D = Y + 1
                X = X - 1
                Y = Y - 1
            End If
            R.Top = StartY + (Y * (Height / lngHeight))
            If (lngWidth < 96) And (lngHeight < 96) Then
                R.Left = StartX + (X * (Width / lngWidth)) - 2
                R.Right = StartX + (C * (Width / lngWidth))
                R.Bottom = StartY + (D * (Height / lngHeight)) + 2
            Else
                R.Left = StartX + (X * (Width / lngWidth))
                R.Right = StartX + (C * (Width / lngWidth)) + 1
                R.Bottom = StartY + (D * (Height / lngHeight)) + 1
            End If
            SizeY = CreateSolidBrush(SizeX)
            Call FillRect(lngHdc, R, SizeY)
            Call DeleteObject(SizeY)
        End If
        A = A + (i + 1)
    Loop
    '//return success
    MapPreview = True
MapPreviewErr:
End Function



